<?php
/**
 * InlineObject3
 *
 * PHP version 7.3
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * TANSS API
 *
 * ## Documentation of the TANSS API. Version: 5.8.22.1  ### older versions Older versions of the API documentation can be found here: * [Docs for 5.8.21.6](https://api-doc.tanss.de/5.8.21.6/) * [Docs for 5.8.21.3](https://api-doc.tanss.de/5.8.21.3/) * [Docs for 5.8.21.1](https://api-doc.tanss.de/5.8.21.1/) * [Docs for 5.8.20.5](https://api-doc.tanss.de/5.8.20.5/) * [Docs for 5.8.20.4](https://api-doc.tanss.de/5.8.20.4/) * [Docs for 5.8.20.2](https://api-doc.tanss.de/5.8.20.2/) * [Docs for 5.8.19.3](https://api-doc.tanss.de/5.8.19.3/)
 *
 * The version of the OpenAPI document: 5.8.22.1
 * Contact: support@tanss.de
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Tanss\Model;

use \ArrayAccess;
use \SLIS\Adapter\Tanss\ObjectSerializer;

/**
 * InlineObject3 Class Doc Comment
 *
 * @category Class
 * @description This object represents a phone call
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<TKey, TValue>
 * @template TKey int|null
 * @template TValue mixed|null
 */
class InlineObject3 implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'inline_object_3';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'id' => 'int',
        'callId' => 'string',
        'telephoneSystemId' => 'int',
        'date' => 'int',
        'fromPhoneNumber' => 'string',
        'fromPhoneNrInfos' => '\SLIS\Adapter\Tanss\Model\ApiCallsV1FromPhoneNrInfos',
        'toPhoneNumber' => 'string',
        'toPhoneNrInfos' => 'object',
        'direction' => 'string',
        'connectionEstablished' => 'bool',
        'durationTotal' => 'int',
        'durationCall' => 'int',
        'group' => 'string',
        'phoneParticipants' => '\SLIS\Adapter\Tanss\Model\ApiCallsV1PhoneParticipants[]'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'id' => null,
        'callId' => null,
        'telephoneSystemId' => null,
        'date' => 'timestamp',
        'fromPhoneNumber' => null,
        'fromPhoneNrInfos' => null,
        'toPhoneNumber' => null,
        'toPhoneNrInfos' => null,
        'direction' => null,
        'connectionEstablished' => null,
        'durationTotal' => null,
        'durationCall' => null,
        'group' => null,
        'phoneParticipants' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'callId' => 'callId',
        'telephoneSystemId' => 'telephoneSystemId',
        'date' => 'date',
        'fromPhoneNumber' => 'fromPhoneNumber',
        'fromPhoneNrInfos' => 'fromPhoneNrInfos',
        'toPhoneNumber' => 'toPhoneNumber',
        'toPhoneNrInfos' => 'toPhoneNrInfos',
        'direction' => 'direction',
        'connectionEstablished' => 'connectionEstablished',
        'durationTotal' => 'durationTotal',
        'durationCall' => 'durationCall',
        'group' => 'group',
        'phoneParticipants' => 'phoneParticipants'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'callId' => 'setCallId',
        'telephoneSystemId' => 'setTelephoneSystemId',
        'date' => 'setDate',
        'fromPhoneNumber' => 'setFromPhoneNumber',
        'fromPhoneNrInfos' => 'setFromPhoneNrInfos',
        'toPhoneNumber' => 'setToPhoneNumber',
        'toPhoneNrInfos' => 'setToPhoneNrInfos',
        'direction' => 'setDirection',
        'connectionEstablished' => 'setConnectionEstablished',
        'durationTotal' => 'setDurationTotal',
        'durationCall' => 'setDurationCall',
        'group' => 'setGroup',
        'phoneParticipants' => 'setPhoneParticipants'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'callId' => 'getCallId',
        'telephoneSystemId' => 'getTelephoneSystemId',
        'date' => 'getDate',
        'fromPhoneNumber' => 'getFromPhoneNumber',
        'fromPhoneNrInfos' => 'getFromPhoneNrInfos',
        'toPhoneNumber' => 'getToPhoneNumber',
        'toPhoneNrInfos' => 'getToPhoneNrInfos',
        'direction' => 'getDirection',
        'connectionEstablished' => 'getConnectionEstablished',
        'durationTotal' => 'getDurationTotal',
        'durationCall' => 'getDurationCall',
        'group' => 'getGroup',
        'phoneParticipants' => 'getPhoneParticipants'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    public const DIRECTION_INTERNAL = 'INTERNAL';
    public const DIRECTION_INCOMING = 'INCOMING';
    public const DIRECTION_OUTGOING = 'OUTGOING';

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getDirectionAllowableValues()
    {
        return [
            self::DIRECTION_INTERNAL,
            self::DIRECTION_INCOMING,
            self::DIRECTION_OUTGOING,
        ];
    }

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['id'] = $data['id'] ?? null;
        $this->container['callId'] = $data['callId'] ?? null;
        $this->container['telephoneSystemId'] = $data['telephoneSystemId'] ?? null;
        $this->container['date'] = $data['date'] ?? null;
        $this->container['fromPhoneNumber'] = $data['fromPhoneNumber'] ?? null;
        $this->container['fromPhoneNrInfos'] = $data['fromPhoneNrInfos'] ?? null;
        $this->container['toPhoneNumber'] = $data['toPhoneNumber'] ?? null;
        $this->container['toPhoneNrInfos'] = $data['toPhoneNrInfos'] ?? null;
        $this->container['direction'] = $data['direction'] ?? null;
        $this->container['connectionEstablished'] = $data['connectionEstablished'] ?? null;
        $this->container['durationTotal'] = $data['durationTotal'] ?? null;
        $this->container['durationCall'] = $data['durationCall'] ?? null;
        $this->container['group'] = $data['group'] ?? null;
        $this->container['phoneParticipants'] = $data['phoneParticipants'] ?? null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        $allowedValues = $this->getDirectionAllowableValues();
        if (!is_null($this->container['direction']) && !in_array($this->container['direction'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value '%s' for 'direction', must be one of '%s'",
                $this->container['direction'],
                implode("', '", $allowedValues)
            );
        }

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets id
     *
     * @return int|null
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param int|null $id id of the phone call (in the TANSS database)
     *
     * @return self
     */
    public function setId($id)
    {
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets callId
     *
     * @return string|null
     */
    public function getCallId()
    {
        return $this->container['callId'];
    }

    /**
     * Sets callId
     *
     * @param string|null $callId (Optional) Describes the external id of the phone call, which is used by the remote phone system
     *
     * @return self
     */
    public function setCallId($callId)
    {
        $this->container['callId'] = $callId;

        return $this;
    }

    /**
     * Gets telephoneSystemId
     *
     * @return int|null
     */
    public function getTelephoneSystemId()
    {
        return $this->container['telephoneSystemId'];
    }

    /**
     * Sets telephoneSystemId
     *
     * @param int|null $telephoneSystemId (Optional) If more than one remote phone systems is used, represents the \"number\" of the phone system
     *
     * @return self
     */
    public function setTelephoneSystemId($telephoneSystemId)
    {
        $this->container['telephoneSystemId'] = $telephoneSystemId;

        return $this;
    }

    /**
     * Gets date
     *
     * @return int|null
     */
    public function getDate()
    {
        return $this->container['date'];
    }

    /**
     * Sets date
     *
     * @param int|null $date Unix timestamp representing the begin of the phone call
     *
     * @return self
     */
    public function setDate($date)
    {
        $this->container['date'] = $date;

        return $this;
    }

    /**
     * Gets fromPhoneNumber
     *
     * @return string|null
     */
    public function getFromPhoneNumber()
    {
        return $this->container['fromPhoneNumber'];
    }

    /**
     * Sets fromPhoneNumber
     *
     * @param string|null $fromPhoneNumber Phone number of the caller (= \"from\" number)
     *
     * @return self
     */
    public function setFromPhoneNumber($fromPhoneNumber)
    {
        $this->container['fromPhoneNumber'] = $fromPhoneNumber;

        return $this;
    }

    /**
     * Gets fromPhoneNrInfos
     *
     * @return \SLIS\Adapter\Tanss\Model\ApiCallsV1FromPhoneNrInfos|null
     */
    public function getFromPhoneNrInfos()
    {
        return $this->container['fromPhoneNrInfos'];
    }

    /**
     * Sets fromPhoneNrInfos
     *
     * @param \SLIS\Adapter\Tanss\Model\ApiCallsV1FromPhoneNrInfos|null $fromPhoneNrInfos fromPhoneNrInfos
     *
     * @return self
     */
    public function setFromPhoneNrInfos($fromPhoneNrInfos)
    {
        $this->container['fromPhoneNrInfos'] = $fromPhoneNrInfos;

        return $this;
    }

    /**
     * Gets toPhoneNumber
     *
     * @return string|null
     */
    public function getToPhoneNumber()
    {
        return $this->container['toPhoneNumber'];
    }

    /**
     * Sets toPhoneNumber
     *
     * @param string|null $toPhoneNumber Phone number of the called (= \"to\" number)
     *
     * @return self
     */
    public function setToPhoneNumber($toPhoneNumber)
    {
        $this->container['toPhoneNumber'] = $toPhoneNumber;

        return $this;
    }

    /**
     * Gets toPhoneNrInfos
     *
     * @return object|null
     */
    public function getToPhoneNrInfos()
    {
        return $this->container['toPhoneNrInfos'];
    }

    /**
     * Sets toPhoneNrInfos
     *
     * @param object|null $toPhoneNrInfos toPhoneNrInfos
     *
     * @return self
     */
    public function setToPhoneNrInfos($toPhoneNrInfos)
    {
        $this->container['toPhoneNrInfos'] = $toPhoneNrInfos;

        return $this;
    }

    /**
     * Gets direction
     *
     * @return string|null
     */
    public function getDirection()
    {
        return $this->container['direction'];
    }

    /**
     * Sets direction
     *
     * @param string|null $direction Defines the \"direction\" of a phone call
     *
     * @return self
     */
    public function setDirection($direction)
    {
        $allowedValues = $this->getDirectionAllowableValues();
        if (!is_null($direction) && !in_array($direction, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value '%s' for 'direction', must be one of '%s'",
                    $direction,
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['direction'] = $direction;

        return $this;
    }

    /**
     * Gets connectionEstablished
     *
     * @return bool|null
     */
    public function getConnectionEstablished()
    {
        return $this->container['connectionEstablished'];
    }

    /**
     * Sets connectionEstablished
     *
     * @param bool|null $connectionEstablished True if a connection was established, otherwise will count as a \"try\"
     *
     * @return self
     */
    public function setConnectionEstablished($connectionEstablished)
    {
        $this->container['connectionEstablished'] = $connectionEstablished;

        return $this;
    }

    /**
     * Gets durationTotal
     *
     * @return int|null
     */
    public function getDurationTotal()
    {
        return $this->container['durationTotal'];
    }

    /**
     * Sets durationTotal
     *
     * @param int|null $durationTotal Total duration of the call (plus ring time) in seconds
     *
     * @return self
     */
    public function setDurationTotal($durationTotal)
    {
        $this->container['durationTotal'] = $durationTotal;

        return $this;
    }

    /**
     * Gets durationCall
     *
     * @return int|null
     */
    public function getDurationCall()
    {
        return $this->container['durationCall'];
    }

    /**
     * Sets durationCall
     *
     * @param int|null $durationCall Duration of the call (only time of actual connection) in seconds
     *
     * @return self
     */
    public function setDurationCall($durationCall)
    {
        $this->container['durationCall'] = $durationCall;

        return $this;
    }

    /**
     * Gets group
     *
     * @return string|null
     */
    public function getGroup()
    {
        return $this->container['group'];
    }

    /**
     * Sets group
     *
     * @param string|null $group (Optional) A group can be assigned to the call (as a string). This is an optional feature.
     *
     * @return self
     */
    public function setGroup($group)
    {
        $this->container['group'] = $group;

        return $this;
    }

    /**
     * Gets phoneParticipants
     *
     * @return \SLIS\Adapter\Tanss\Model\ApiCallsV1PhoneParticipants[]|null
     */
    public function getPhoneParticipants()
    {
        return $this->container['phoneParticipants'];
    }

    /**
     * Sets phoneParticipants
     *
     * @param \SLIS\Adapter\Tanss\Model\ApiCallsV1PhoneParticipants[]|null $phoneParticipants phoneParticipants
     *
     * @return self
     */
    public function setPhoneParticipants($phoneParticipants)
    {
        $this->container['phoneParticipants'] = $phoneParticipants;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


